#!/bin/sh

TESTRTDIR=$1

if [ `uname` = "Linux" ]
then
	if [ -x $TESTRTDIR/MakeLinkToDynamiclib.sh ]
	then
	  $TESTRTDIR/MakeLinkToDynamiclib.sh "$TESTRTDIR"
	fi
fi

if [ -s $TESTRTDIR/testrtinit.sh ]
then
. $TESTRTDIR/testrtinit.sh
else
  echo $TESTRTDIR/testrtinit.sh not found
  exit
fi
if [ "$2" = "local" ]
then
  echo TDP generation in current directory
else
  cd  $TESTRTDIR/targets
fi
TARGETS=`pwd`

echo "Generating adagnat TDP"
TestRTperl -I $TESTRTDIR/lib/perl $TESTRTDIR/lib/scripts/tdpgen.pl $TESTRTDIR/targets/xml/adagnat.xdp $TARGETS
#echo "Generating adaunxapex TDP"
#TestRTperl -I $TESTRTDIR/lib/perl $TESTRTDIR/lib/scripts/tdpgen.pl $TESTRTDIR/targets/xml/adaunxapex.xdp $TARGETS

#echo "Generating cunxdiabsgstep TDP"
#TestRTperl -I $TESTRTDIR/lib/perl $TESTRTDIR/lib/scripts/tdpgen.pl $TESTRTDIR/targets/xml/cunxdiabsgstep.xdp $TARGETS

rm log_gcc_configuration.log  2>/dev/null
which gcc > log_gcc_configuration.log 2>&1
RETURN_CODE_GCC=$?
which g++ >> log_gcc_configuration.log 2>&1
RETURN_CODE_GPP=$?
#if gcc found the Return_code value is 0

if [ $RETURN_CODE_GCC -eq 0 ]
then
   #gcc found. make sure this is not the GNAT compiler
   grep -i gnat log_gcc_configuration.log
   RETURN_CODE=$?
   if [ $RETURN_CODE -eq 0 ]
   then
      rm log_gcc_configuration.log  2>/dev/null
      which /usr/bin/gcc > log_gcc_configuration.log 2>&1
      RETURN_CODE_GCC=$?
      which /usr/bin/g++ >> log_gcc_configuration.log 2>&1
      RETURN_CODE_GPP=$?
      #if gcc found the Return_code value is 0
   fi
fi

if [ $RETURN_CODE_GCC -eq 0 ]
then
  # generate cgnu.xdp from appropriate xdp then generate cgnu TDP
  TestRTperl -I $TESTRTDIR/lib/perl $TESTRTDIR/lib/scripts/ConfigureGcc.pl -silent $TARGETS
  # if the machine is 64bits machine ConfigureGcc.pl generate cgnu.xdp accordingly

else
  echo "gcc not found. Please start ConfigureGcc.sh manually." >> log_gcc_configuration.log
  echo "gcc not found. Please start ConfigureGcc.sh manually."

fi

if [ `uname` = "Linux" ]
then

	if [ `uname -m` = "i686" ]
    then
    	echo "Generating clinuxgnu TDP"
		TestRTperl -I $TESTRTDIR/lib/perl $TESTRTDIR/lib/scripts/tdpgen.pl $TESTRTDIR/targets/xml/clinuxgnu.xdp $TARGETS
    	echo "Generating clinuxgnu3breakpoint TDP"
		TestRTperl -I $TESTRTDIR/lib/perl $TESTRTDIR/lib/scripts/tdpgen.pl $TESTRTDIR/targets/xml/clinuxgnu3breakpoint.xdp $TARGETS
    	echo "Generating clinuxgnu3socket TDP"
		TestRTperl -I $TESTRTDIR/lib/perl $TESTRTDIR/lib/scripts/tdpgen.pl $TESTRTDIR/targets/xml/clinuxgnu3socket.xdp $TARGETS
    elif [ `uname -m` = "x86_64" ]
    then
    	echo "Generating clinuxgnu TDP"
    	TestRTperl -I $TESTRTDIR/lib/perl $TESTRTDIR/lib/scripts/tdpgen.pl $TESTRTDIR/targets/xml/clinuxgnu.xdp $TARGETS

    	echo "Generating clinuxgnu64 TDP"
    	TestRTperl -I $TESTRTDIR/lib/perl $TESTRTDIR/lib/scripts/tdpgen.pl $TESTRTDIR/targets/xml/clinuxgnu64.xdp $TARGETS
    fi
fi


cd $TESTRTDIR
